unit tva_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons;

const
  Version_ = ' TVA - v.1.7 by Didier GERARD';
  //Couleurs
  ColBeige_ = clCream;
  ColGris_ = clSilver;
  ColBleu_ = $00FFC993;
  ColVert_ = $008CFF8C;
  ColRose_ = $00C1C1FF;
  ColJaune_ = clYellow;

type

  { TWdMain }

  TWdMain = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    SpeedButton1: TSpeedButton;
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure Edit2Change(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure Edit3Change(Sender: TObject);
    procedure Edit3KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure Edit4Change(Sender: TObject);
    procedure Edit4KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
    procedure RadioButton3Change(Sender: TObject);
    procedure RadioButton4Change(Sender: TObject);
    procedure RadioButton5Change(Sender: TObject);
    procedure RadioButton6Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;
  Select: byte;

implementation

{$R *.lfm}

{ TWdMain }

//Real en String, 2 décimales
function RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

function If_Chiffre(s: string): boolean;
var
  n, Lg, Ch, Vi, Au: integer;
begin
  Lg := Length(s);
  Ch := 0;
  Vi := 0;
  Au := 0;
  for n := 1 to Lg do
  begin
    if s[n] in ['0'..'9'] then
    begin
      Inc(Ch);
    end
    else
    begin
      if (s[n] = ',') or (s[n] = '.') then
        Inc(Vi)
      else
        Inc(Au);
    end;
  end;
  if (Au = 0) and (Vi < 2) then
    Result := True
  else
    Result := False;
end;

function Convert_Virgule(s: string): string;
var
  St: string;
  n: integer;
begin
  St := s;
  for n := 1 to Length(St) do
    if St[n] = ',' then
      St[n] := '.';
  Result := St;
end;

//-----Résumé des formules------
//TTC      TTC=HT+(HT*(TVA/100))
//TVA_1    TVA=((TTC-HT)/HT)*100
//TVA_2    TVA=(PartTVA*100)/HT
//HT_1     HT=TTC/(1+(TVA/100))
//HT_2     HT=(PartTVA*100)/TVA
//HT_3     HT=TTC-PartTVA
//PartTVA  PartTVA=(HT*TVA)/100;

function Calcul_TTC(HT, TVA: real): real;
begin
  //TTC=HT+(HT*(TVA/100))
  Result := HT + (HT * (TVA / 100));
end;

function Calcul_TVA_1(TTC, HT: real): real;
begin
  //TVA=((TTC-HT)/HT)*100
  Result := ((TTC - HT) / HT) * 100;
end;

function Calcul_TVA_2(HT, PartTVA: real): real;
begin
  //TVA=(PartTVA*100)/HT
  Result := (PartTVA * 100) / HT;
end;

function Calcul_HT_1(TTC, TVA: real): real;
begin
  //HT=TTC/(1+(TVA/100))
  Result := TTC / (1 + (TVA / 100));
end;

function Calcul_HT_2(TVA, PartTVA: real): real;
begin
  //HT=(PartTVA*100)/TVA
  Result := (PartTVA * 100) / TVA;
end;

function Calcul_HT_3(TTC, PartTVA: real): real;
begin
  //HT=TTC-PartTVA
  Result := TTC - PartTVA;
end;

function Calcul_PartTVA(HT, TVA: real): real;
begin
  //PartTVA=(HT*TVA)/100;
  Result := (HT * TVA) / 100;
end;

procedure Affiche;
begin
  with WdMain do
  begin
    Edit1.Text := '';
    Edit1.Color := ColGris_;
    Edit2.Text := '';
    Edit2.Color := ColGris_;
    Edit3.Text := '';
    Edit3.Color := ColGris_;
    Edit4.Text := '';
    Edit4.Color := ColGris_;

    case Select of
      //Connu:TTC et TVA -> Calcul:HT et Part TVA
      1:
      begin
        //TTC
        Edit1.ReadOnly := False;
        Edit1.Color := ColBeige_;
        Edit1.Cursor := crHandPoint;
        //TVA
        Edit2.ReadOnly := False;
        Edit2.Color := ColBeige_;
        Edit2.Cursor := crHandPoint;
        //HT
        Edit3.Color := ColGris_;
        Edit3.Cursor := crDefault;
        Edit3.ReadOnly := True;
        //Part TVA
        Edit4.Color := ColGris_;
        Edit4.Cursor := crDefault;
        Edit4.ReadOnly := True;

        ActiveControl := Edit1;
      end;
      //Connu:TVA et HT -> Calcul TTC et Part TVA
      2:
      begin
        //TTC
        Edit1.Color := ColGris_;
        Edit1.Cursor := crDefault;
        Edit1.ReadOnly := True;
        //TVA
        Edit2.ReadOnly := False;
        Edit2.Color := ColBeige_;
        Edit2.Cursor := crHandPoint;
        //HT
        Edit3.ReadOnly := False;
        Edit3.Color := ColBeige_;
        Edit3.Cursor := crHandPoint;
        //Part TVA
        Edit4.Color := ColGris_;
        Edit4.Cursor := crDefault;
        Edit4.ReadOnly := True;

        ActiveControl := Edit2;
      end;
      //Connu:TTC et HT -> Calcul TVA et Part TVA
      3:
      begin
        //TTC
        Edit1.ReadOnly := False;
        Edit1.Color := ColBeige_;
        Edit1.Cursor := crHandPoint;
        //TVA
        Edit2.Color := ColGris_;
        Edit2.Cursor := crDefault;
        Edit2.ReadOnly := True;
        //HT
        Edit3.ReadOnly := False;
        Edit3.Color := ColBeige_;
        Edit3.Cursor := crHandPoint;
        //Part TVA
        Edit4.Color := ColGris_;
        Edit4.Cursor := crDefault;
        Edit4.ReadOnly := True;

        ActiveControl := Edit1;
      end;
      //Connu:HT et Part TVA -> Calcul TVA et TTC
      4:
      begin
        //TTC
        Edit1.ReadOnly := False;
        Edit1.Color := ColBeige_;
        Edit1.Cursor := crHandPoint;
        //TVA
        Edit2.Color := ColGris_;
        Edit2.Cursor := crDefault;
        Edit2.ReadOnly := True;
        //HT
        Edit3.Color := ColGris_;
        Edit3.Cursor := crDefault;
        Edit3.ReadOnly := True;
        //Part TVA
        Edit4.ReadOnly := False;
        Edit4.Color := ColBeige_;
        Edit4.Cursor := crHandPoint;

        ActiveControl := Edit1;
      end;
      //Connu:TVA et Part TVA -> Calcul TTC et HT
      5:
      begin
        //TTC
        Edit1.Color := ColGris_;
        Edit1.Cursor := crDefault;
        Edit1.ReadOnly := True;
        //TVA
        Edit2.ReadOnly := False;
        Edit2.Color := ColBeige_;
        Edit2.Cursor := crHandPoint;
        //HT
        Edit3.Color := ColGris_;
        Edit3.Cursor := crDefault;
        Edit3.ReadOnly := True;
        //Part TVA
        Edit4.ReadOnly := False;
        Edit4.Color := ColBeige_;
        Edit4.Cursor := crHandPoint;

        ActiveControl := Edit2;
      end;
      //Connu:HT et Part TVA -> Calcul TTC et TVA
      6:
      begin
        //TTC
        Edit1.Color := ColGris_;
        Edit1.Cursor := crDefault;
        Edit1.ReadOnly := True;
        //TVA
        Edit2.Color := ColGris_;
        Edit2.Cursor := crDefault;
        Edit2.ReadOnly := True;
        //HT
        Edit3.ReadOnly := False;
        Edit3.Color := ColBeige_;
        Edit3.Cursor := crHandPoint;
        //Part TVA
        Edit4.ReadOnly := False;
        Edit4.Color := ColBeige_;
        Edit4.Cursor := crHandPoint;

        ActiveControl := Edit3;
      end;
    end;
  end;
end;

procedure Calcul;
var
  sTTC, sTVA, sHT, sPartTVA: string;
  TTC, TVA, HT, PartTVA: real;
begin
  with WdMain do
  begin
    //TTC
    sTTC := Edit1.Text;
    if if_Chiffre(sTTC) then
    begin
      sTTC := Convert_Virgule(sTTC);
      TTC := StrToReal(sTTC);
    end;
    //TVA
    sTVA := Edit2.Text;
    if if_Chiffre(sTVA) then
    begin
      sTVA := Convert_Virgule(sTVA);
      TVA := StrToReal(sTVA);
    end;
    //HT
    sHT := Edit3.Text;
    if if_Chiffre(sHT) then
    begin
      sHT := Convert_Virgule(sHT);
      HT := StrToReal(sHT);
    end;
    //Part TVA
    sPartTVA := Edit4.Text;
    if if_Chiffre(sPartTVA) then
    begin
      sPartTVA := Convert_Virgule(sPartTVA);
      PartTVA := StrToReal(sPartTVA);
    end;

    //TVA à 5,5 % - 8,5 % - 10 % - à 20 %

    case Select of
      //Connu:TTC et TVA -> Calcul:HT et Part TVA
      1: if (TTC > 0) and (TVA > 0) then
        begin
          //HT
          HT := Calcul_HT_1(TTC, TVA);
          Edit3.Text := RealToStr(HT, 3);
          //Part TVA
          PartTVA := Calcul_PartTVA(HT, TVA);
          Edit4.Text := RealToStr(PartTVA, 3);
        end;
      //Connu:TVA et HT -> Calcul TTC et Part TVA
      2: if (TVA > 0) and (HT > 0) then
        begin
          //TTC
          TTC := Calcul_TTC(HT, TVA);
          Edit1.Text := RealToStr(TTC, 3);
          //Part TVA
          PartTVA := Calcul_PartTVA(HT, TVA);
          Edit4.Text := RealToStr(PartTVA, 3);
        end;
      //Connu:TTC et HT -> Calcul TVA et Part TVA
      3: if (TTC > 0) and (HT > 0) then
        begin
          //TVA
          TVA := Calcul_TVA_1(TTC, HT);
          Edit2.Text := RealToStr(TVA, 3);
          //PartTVA
          PartTVA := Calcul_PartTVA(HT, TVA);
          Edit4.Text := RealToStr(PartTVA, 3);
        end;
      //Connu:TTC et Part TVA -> Calcul TVA et HT
      4: if (TTC > 0) and (PartTVA > 0) then
        begin
          //HT
          HT := Calcul_HT_3(TTC, PartTVA);
          Edit3.Text := RealToStr(HT, 3);
          //TVA
          TVA := Calcul_TVA_1(TTC, HT);
          Edit2.Text := RealToStr(TVA, 3);
        end;
      //Connu:TVA et Part TVA -> Calcul TTC et HT
      5: if (TVA > 0) and (PartTVA > 0) then
        begin
          //HT
          HT := Calcul_HT_2(TVA, PartTVA);
          Edit3.Text := RealToStr(HT, 3);
          //TTC
          TTC := Calcul_TTC(HT, TVA);
          Edit1.Text := RealToStr(TTC, 3);
        end;
      //Connu:HT et Part TVA -> Calcul TTC et TVA
      6: if (HT > 0) and (PartTVA > 0) then
        begin
          //TVA
          TVA := Calcul_TVA_2(HT, PartTVA);
          Edit2.Text := RealToStr(TVA, 3);
          //TTC
          TTC := Calcul_TTC(HT, TVA);
          Edit1.Text := RealToStr(TTC, 3);
        end;
    end;
  end;
end;

procedure Change_Edit;
begin
  with WdMain do
  begin
    case Select of
      1: if Edit1.Focused then
          ActiveControl := Edit2;
      2: if Edit2.Focused then
          ActiveControl := Edit3;
      3: if Edit1.Focused then
          ActiveControl := Edit3;
      4: if Edit1.Focused then
          ActiveControl := Edit4;
      5: if Edit2.Focused then
          ActiveControl := Edit4;
      6: if Edit3.Focused then
          ActiveControl := Edit4;
    end;
  end;
end;

procedure TWdMain.Edit1KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
  begin
    Change_Edit;
    Key := 0;
  end;
end;

procedure TWdMain.Edit2KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
  begin
    Change_Edit;
    Key := 0;
  end;
end;

procedure TWdMain.Edit3KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
  begin
    Change_Edit;
    Key := 0;
  end;
end;

procedure TWdMain.Edit4KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
  begin
    Change_Edit;
    Key := 0;
  end;
end;

procedure TWdMain.Edit1Change(Sender: TObject);
begin
  if Edit1.Text = '' then
    Edit1.Color := ColBeige_
  else
    Edit1.Color := ColBleu_;
  Calcul;
end;

procedure TWdMain.Edit2Change(Sender: TObject);
begin
  if Edit2.Text = '' then
    Edit2.Color := ColBeige_
  else
    Edit2.Color := ColVert_;
  Calcul;
end;

procedure TWdMain.Edit3Change(Sender: TObject);
begin
  if Edit3.Text = '' then
    Edit3.Color := ColBeige_
  else
    Edit3.Color := ColRose_;
  Calcul;
end;

procedure TWdMain.Edit4Change(Sender: TObject);
begin
  if Edit4.Text = '' then
    Edit4.Color := ColBeige_
  else
    Edit4.Color := ColJaune_;
  Calcul;
end;

procedure TWdMain.RadioButton1Change(Sender: TObject);
begin
  Select := 1;
  Affiche;
end;

procedure TWdMain.RadioButton2Change(Sender: TObject);
begin
  Select := 2;
  Affiche;
end;

procedure TWdMain.RadioButton3Change(Sender: TObject);
begin
  Select := 3;
  Affiche;
end;

procedure TWdMain.RadioButton4Change(Sender: TObject);
begin
  Select := 4;
  Affiche;
end;

procedure TWdMain.RadioButton5Change(Sender: TObject);
begin
  Select := 5;
  Affiche;
end;

procedure TWdMain.RadioButton6Change(Sender: TObject);
begin
  Select := 6;
  Affiche;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  WdMain.Caption := Version_;

  Select := 1;
  Affiche;
end;

end.
